# Class XmlNmrmlReader

java.lang.Object
org.jmol.adapter.smarter.AtomSetCollectionReader
org.jmol.adapter.readers.xml.XmlReader
org.jmol.adapter.readers.xml.XmlCmlReader
org.jmol.adapter.readers.xml.XmlNmrmlReader

All Implemented Interfaces:
  `GenericLineReader`

public class XmlNmrmlReader extends XmlCmlReader
A reader for the structure part of an nmrML file

## Field Summary

### Fields inherited from class XmlCmlReader

`ASSOCIATION, CML, CRYSTAL, CRYSTAL_SCALAR, CRYSTAL_SYMMETRY, CRYSTAL_SYMMETRY_TRANSFORM3, htModelAtomMap, LATTICE_VECTOR, MODULE, MOLECULE, MOLECULE_ATOM, MOLECULE_ATOM_ARRAY, MOLECULE_ATOM_BUILTIN, MOLECULE_ATOM_SCALAR, MOLECULE_BOND, MOLECULE_BOND_ARRAY, MOLECULE_BOND_BUILTIN, MOLECULE_BOND_STEREO, MOLECULE_FORMULA, moleculeID, processing, START, state, SYMMETRY, tokens`

### Fields inherited from class XmlReader

`atts, chars, keepChars, parent, thisAtom`

### Fields inherited from class AtomSetCollectionReader

`addedData, addedDataKey, addVibrations, allow_a_len_1, allowPDBFilter, ANGSTROMS_PER_BOHR, applySymmetryToBonds, asc, baseAtomIndex, baseBondIndex, binaryDoc, bsFilter, bsModels, calculationType, CELL_TYPE_CONVENTIONAL, CELL_TYPE_PRIMITIVE, CELL_TYPE_SUPER, cellSlop, centroidPacked, checkNearAtoms, continuing, debugging, desiredModelNumber, desiredSpaceGroupIndex, desiredVibrationNumber, doApplySymmetry, doCentralize, doCentroidUnitCell, doCheckUnitCell, doConvertToFractional, doPackUnitCell, doProcessLines, doReadMolecularOrbitals, dssr, fileName, fileOffset, filePath, fileScaling, fillRange, filter, filterAllHetero, filterCased, filteredPrecision, filterHetero, floatifyJavaDouble, forcePacked, getHeader, haveAtomFilter, haveModel, havePartialChargeFilter, htParams, ignoreFileSpaceGroupName, ignoreFileSymmetryOperators, ignoreFileUnitCell, ignoreStructure, iHaveFractionalCoordinates, iHaveSymmetryOperators, iHaveUnitCell, is2D, isBinary, isConcatenated, isDSSP1, isFinalized, isMolecular, isPrimitive, isSequential, isSUPERCELL, isTrajectory, latticeCells, latticeScaling, latticeType, line, lowPrecision, lstNCS, matUnitCellOrientation, merging, modDim, modelNumber, ms, mustFinalizeModelSet, next, noHydrogens, noMinimize, noPack, optimize2D, out, paramsCentroid, paramsLattice, precision, prevline, primitiveToCrystal, ptLine, ptSupercell, reader, readerName, requiresBSFilter, reverseModels, rotateHexCell, sgName, slabXY, stateScriptVersionInt, strSupercell, symmetry, templateAtomCount, thisBiomolecule, trajectorySteps, ucItems, unitCellOffset, unitCellParams, useAltNames, useFileModelNumbers, validation, vibrationNumber, vibsFractional, vwr`

## Constructor Summary

Constructors
Constructor
Description
`XmlNmrmlReader()`

## Method Summary

Modifier and Type
Method
Description
`protected BufferedReader`
`previewXML(BufferedReader reader)`
fixing unterminated cv element and unclosed chemicalShiftStandard start element not fixing trailing '"' after bond elements Just two times through this before we are done.
`void`
`processEnd2(String name)`
`protected void`
`processStart2(String name)`

### Methods inherited from class XmlCmlReader

`applySymmetryAndSetTrajectory, endDocument, processStartElement, processXml`

### Methods inherited from class XmlReader

`finalizeSubclassReader, initializeReader, processDOM, processXml2, setKeepChars`

### Methods inherited from class AtomSetCollectionReader

`addAtomXYZSymName, addExplicitLatticeVector, addJmolScript, addMoreUnitCellInfo, addSites, addSiteScript, appendLoadNote, applySymTrajASCR, checkAndRemoveFilterKey, checkCurrentLineForScript, checkFilterKey, checkLastModel, checkLine, checkLineForScript, clearUnitCell, cloneLastAtomSet, discardLinesUntilBlank, discardLinesUntilContains, discardLinesUntilContains2, discardLinesUntilNonBlank, discardLinesUntilStartsWith, discardPreviousAtoms, doGetModel, doGetVibration, doPreSymmetry, fill3x3, fillDataBlock, fillDataBlockFixed, fillFloatArray, fillFrequencyData, filterAtom, filterReject, finalizeMOData, finalizeModelSet, finalizeReaderASCR, finalizeSubclassSymmetry, fixDoubleA, fixFloatA, fixFloatPt, forceSymmetry, fractionalizeCoordinates, getElementSymbol, getFilter, getFilterWithCase, getFortranFormatLengths, getInterface, getPackingRangeValue, getStrings, getSymmetry, getTokens, getTokensFloat, initializeSymmetry, initializeSymmetryOptions, initializeTrajectoryFile, isLastModel, newAtomSet, parseFloat, parseFloatRange, parseFloatStr, parseInt, parseIntAt, parseIntRange, parseIntStr, parsePrecision, parseToken, parseTokenNext, parseTokenRange, parseTokenStr, processBinaryDocument, rd, read3Vectors, readDataObject, readLines, readNextLine, rejectAtomName, RL, set2D, setAtomCoord, setAtomCoordScaled, setAtomCoordTokens, setAtomCoordXYZ, setChainID, setElementAndIsotope, setFilter, setFilterAtomTypeStr, setFractionalCoordinates, setIsPDB, setLoadNote, setModelPDB, setPrecision, setSpaceGroupName, setSymmetryOperator, setTransform, setUnitCell, setUnitCellItem, setup, setupASCR, warnSkippingOperation`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### XmlNmrmlReader

public XmlNmrmlReader()

## Method Details

### previewXML

protected BufferedReader previewXML(BufferedReader reader) throws IOException
fixing unterminated cv element and unclosed chemicalShiftStandard start element not fixing trailing '"' after bond elements Just two times through this before we are done. First read will be only 64 bytes long and ignored; second will be around 9000 bytes and will be handled.

Overrides:
  `previewXML` in class `XmlReader`
Parameters:
  `reader` -
Returns:
  repaired reader
Throws:
  `IOException`

### processStart2

protected void processStart2(String name)

Overrides:
  `processStart2` in class `XmlCmlReader`

### processEnd2

public void processEnd2(String name)

Overrides:
  `processEnd2` in class `XmlCmlReader`